//   8 
module JTAGcore  (GREEN_LED, RED_LED, 			
				  N_RD, WR,		
                  JTCK, N_CONF, N_CS, N_CE, ASDI,  
 				  CDONE, DATAOUT,
	              d[7:0], CLK,
                  N_RXF, N_TXE,  RESET);

  input RESET;	       // 
  input N_TXE, N_RXF;  // FT245  / 
  input CLK;           //  EPM3064

  inout [7:0]d;        //    EPM3064  FT245

  output GREEN_LED, RED_LED;                // 

// JTAG  
  input CDONE, DATAOUT;
  output JTCK, N_CONF, N_CS, N_CE, ASDI;    //  JTAG/Config
  
  output N_RD, WR;     //  FT245
  
  reg[7:0] From_FT245;	//     FT245
  reg[7:0] To_FT245;	//      FT245
   

//        
  wire RXF, TXE;	
  reg RD,WR;
  
  reg tmp;

  reg[1:0] RD_SM;	// State Machine    FT245
  parameter Idle=0, RD_Active=1, WR_Active=2;

assign GREEN_LED=From_FT245[6];
assign RED_LED  =From_FT245[7];

assign JTCK     =From_FT245[0];
assign N_CONF   =From_FT245[1];
assign N_CE     =From_FT245[2];
assign N_CS     =From_FT245[3];
assign ASDI     =From_FT245[4];

assign RXF = ~ N_RXF;	//     
assign TXE = ~ N_TXE;	//      
assign N_RD = ~ RD;		//      	

assign d = WR ? To_FT245 : 8'bZ ;
//assign data<=d;
//assign outp  = bidir;


always@(RD or WR)
 begin
  if ((RD) && !(WR))
   begin
    From_FT245[7:0]<= d[7:0];	//     
   end
  else if (WR)
   begin 
    To_FT245[7:2]<=From_FT245[7:2];       //     
    To_FT245[1]<=CDONE;
	To_FT245[0]<=DATAOUT;
   end
  end


//    FT245
//    

always@(posedge CLK or posedge RESET)
begin
 if (RESET) 
  begin
   RD_SM=Idle;
   RD=0;
   WR=0;	
   tmp=0;
  end
  else
   case(RD_SM)
    Idle:  if (tmp)  //       FT245
     begin
      if (TXE)		 //     FT245?
       begin
        RD_SM=WR_Active;
        WR=1;
        RD=0; 
	    tmp=0;
	   end
	 end
	else if (RXF)   //       FT245
	 begin
	  RD_SM=RD_Active;
	  WR=0;
	  RD=1;
	  tmp=1;
	 end
	
    RD_Active:
     begin
      RD_SM=Idle;
      WR=0;
      RD=0; 
     end

	WR_Active:
	 begin
      RD_SM=Idle;
      WR=0;
      RD=0;
      tmp=0; 
     end

     default:
      begin
      RD_SM=Idle;
      WR=0;
      RD=0;
      tmp=0;
     end
   endcase 
end //always@(posedge CLK or posedge RESET)

endmodule

